/*
Inbox

Inbox API can be used for low level integration and enables direct communication with you contact base.   In most cases you will use our interaction templates for communication, but our api also allows you to send message directly.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package inboxapi

import (
	"encoding/json"
)

// checks if the SegmentsEditList type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &SegmentsEditList{}

// SegmentsEditList struct for SegmentsEditList
type SegmentsEditList struct {
	Segments []Segment `json:"segments,omitempty"`
}

// NewSegmentsEditList instantiates a new SegmentsEditList object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewSegmentsEditList() *SegmentsEditList {
	this := SegmentsEditList{}
	return &this
}

// NewSegmentsEditListWithDefaults instantiates a new SegmentsEditList object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewSegmentsEditListWithDefaults() *SegmentsEditList {
	this := SegmentsEditList{}
	return &this
}

// GetSegments returns the Segments field value if set, zero value otherwise.
func (o *SegmentsEditList) GetSegments() []Segment {
	if o == nil || IsNil(o.Segments) {
		var ret []Segment
		return ret
	}
	return o.Segments
}

// GetSegmentsOk returns a tuple with the Segments field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *SegmentsEditList) GetSegmentsOk() ([]Segment, bool) {
	if o == nil || IsNil(o.Segments) {
		return nil, false
	}
	return o.Segments, true
}

// HasSegments returns a boolean if a field has been set.
func (o *SegmentsEditList) HasSegments() bool {
	if o != nil && !IsNil(o.Segments) {
		return true
	}

	return false
}

// SetSegments gets a reference to the given []Segment and assigns it to the Segments field.
func (o *SegmentsEditList) SetSegments(v []Segment) {
	o.Segments = v
}

func (o SegmentsEditList) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o SegmentsEditList) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Segments) {
		toSerialize["segments"] = o.Segments
	}
	return toSerialize, nil
}

type NullableSegmentsEditList struct {
	value *SegmentsEditList
	isSet bool
}

func (v NullableSegmentsEditList) Get() *SegmentsEditList {
	return v.value
}

func (v *NullableSegmentsEditList) Set(val *SegmentsEditList) {
	v.value = val
	v.isSet = true
}

func (v NullableSegmentsEditList) IsSet() bool {
	return v.isSet
}

func (v *NullableSegmentsEditList) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableSegmentsEditList(val *SegmentsEditList) *NullableSegmentsEditList {
	return &NullableSegmentsEditList{value: val, isSet: true}
}

func (v NullableSegmentsEditList) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableSegmentsEditList) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


